unit PCS_Runx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Run: TSpeedButton;
    Single: TButton;
    ShowPCS100: TButton;
    HidePCS100: TButton;
    DataRead: TButton;
    GroupBox1: TGroupBox;
    Label11: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    LabelCh2: TLabel;
    LabelCh1: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton24: TSpeedButton;
    Time_div: TGroupBox;
    Trigger: TGroupBox;
    Label4: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label16: TLabel;
    TrackBar3: TTrackBar;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton30: TSpeedButton;
    SpeedButton31: TSpeedButton;
    SpeedButton32: TSpeedButton;
    SpeedButton33: TSpeedButton;
    SpeedButton34: TSpeedButton;
    SpeedButton35: TSpeedButton;
    SpeedButton36: TSpeedButton;
    SpeedButton37: TSpeedButton;
    SpeedButton38: TSpeedButton;
    SpeedButton39: TSpeedButton;
    SpeedButton40: TSpeedButton;
    SpeedButton41: TSpeedButton;
    SpeedButton42: TSpeedButton;
    SpeedButton43: TSpeedButton;
    SpeedButton44: TSpeedButton;
    SpeedButton45: TSpeedButton;
    SpeedButton46: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    SpeedButton47: TSpeedButton;
    SpeedButton48: TSpeedButton;
    Button4: TButton;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    Label6: TLabel;
    Label9: TLabel;
    Edit4: TEdit;
    Label10: TLabel;
    Label12: TLabel;
    Edit5: TEdit;
    Label13: TLabel;
    Label18: TLabel;
    Edit6: TEdit;
    Label19: TLabel;
    Edit7: TEdit;
    Label20: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    procedure DataReadClick(Sender: TObject);
    procedure RunClick(Sender: TObject);
    procedure SingleClick(Sender: TObject);
    procedure ShowPCS100Click(Sender: TObject);
    procedure HidePCS100Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure SpeedButton32Click(Sender: TObject);
    procedure SpeedButton25Click(Sender: TObject);
    procedure SpeedButton26Click(Sender: TObject);
    procedure SpeedButton27Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton22Click(Sender: TObject);
    procedure SpeedButton30Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure StringsToFloat;
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  data1, data2: array[0..5000] of longint;
  s:string;
  freq,ampl,start,stop,tim:single;

implementation

{$R *.DFM}
{DLL procedures and functions}
//--------------- Oscilloscope ---------------------
PROCEDURE Voltage1(VpDiv:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE Voltage2(VpDiv:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE Time(TpDiv:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE RunOn(Run: Boolean);stdcall; external 'PCSU200.dll';
PROCEDURE SingleOn(Single: Boolean);stdcall; external 'PCSU200.dll';
PROCEDURE YPosition1(y_pos:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE YPosition2(y_pos:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE TrgOn(trg_on: Boolean);stdcall; external 'PCSU200.dll';
PROCEDURE TrgLevel(TrgLevel:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE TrgSource(CH1_CH2:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE TrgEdge(Positive_Negative:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE Coupling1(AC_DC_GND:Longint);stdcall; external 'PCSU200.dll';
PROCEDURE Coupling2(AC_DC_GND:Longint);stdcall; external 'PCSU200.dll';
procedure Show_PCSU200(Visible: Boolean); stdcall; external 'PCSU200.dll';          //1.0
function Start_PCSU200:Boolean; stdcall; external 'PCSU200.dll';                    //1.0
procedure Stop_PCSU200; stdcall; external 'PCSU200.dll';                            //1.0
function GetSettings(SettingsArray: Pointer): Boolean ; stdcall; external 'PCSU200.dll';
procedure ReadCh1(Buffer: Pointer); stdcall; external 'PCSU200.dll';
procedure ReadCh2(Buffer: Pointer); stdcall; external 'PCSU200.dll';
function DataReady:Boolean; stdcall; external 'PCSU200.dll';

//--------------- Function Generator ---------------------
procedure StartGen; stdcall; external 'PCSU200.dll';
procedure StopGen; stdcall; external 'PCSU200.dll';
function GenReady: Boolean; stdcall; external 'PCSU200.dll';
procedure SetGen(func: Longint; freq, ampl: Single) ; stdcall; external 'PCSU200.dll';     //1.0
procedure SetSweep(freq1, freq2, ampl, time: Single); stdcall; external 'PCSU200.dll';     //1.0
procedure SetLibWave(freq, ampl: Single; FileName:PChar); stdcall; external 'PCSU200.dll'; //1.0


procedure TForm1.DataReadClick(Sender: TObject);
var i: longint;
p:pointer;
begin
  p:= @data1[0];
  ReadCh1(p);
  p:= @data2[0];
  ReadCh2(p);
  memo1.clear;
  memo1.lines.add('Sample rate [Hz]'+chr(9)+inttostr(data1[0])+chr(9)+inttostr(data2[0]));
  memo1.lines.add('Full scale [mV]'+chr(9)+inttostr(data1[1])+chr(9)+inttostr(data2[1]));
  memo1.lines.add('GND level [counts]'+chr(9)+inttostr(data1[2])+chr(9)+inttostr(data2[2]));
  memo1.lines.add('');
  begin
    for i:=0 to 10 do
    memo1.lines.add('Data ('+inttostr(i)+')'+chr(9)+chr(9)+inttostr(data1[i+3])+chr(9)+inttostr(data2[i+3]));
  end;
end;

procedure TForm1.RunClick(Sender: TObject);
begin
   RunOn(Run.Down);
   Single.enabled:=not Run.Down;
end;

procedure TForm1.SingleClick(Sender: TObject);
begin
  SingleOn(true);
end;

procedure TForm1.ShowPCS100Click(Sender: TObject);
begin
  Show_PCSU200(true);            //1.0
end;

procedure TForm1.HidePCS100Click(Sender: TObject);
begin
   Show_PCSU200(false);          //1.0
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  YPosition1(TrackBar1.position);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  YPosition2(TrackBar2.position);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Voltage1((sender as TSpeedButton).tag);
end;

procedure TForm1.SpeedButton13Click(Sender: TObject);
begin
  Voltage2((sender as TSpeedButton).tag);
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  Coupling1((sender as TSpeedButton).tag);
end;

procedure TForm1.SpeedButton22Click(Sender: TObject);
begin
  Coupling2((sender as TSpeedButton).tag);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
  TrgLevel(TrackBar3.position);
end;

procedure TForm1.SpeedButton32Click(Sender: TObject);
begin
  Time((sender as TSpeedButton).tag);
end;

procedure TForm1.SpeedButton25Click(Sender: TObject);
begin
  TrgOn(true);
end;

procedure TForm1.SpeedButton26Click(Sender: TObject);
begin
  TrgOn(false);
end;

procedure TForm1.SpeedButton27Click(Sender: TObject);
begin
  TrgSource((sender as TSpeedButton).tag);
end;

procedure TForm1.SpeedButton30Click(Sender: TObject);
begin
  TrgEdge((sender as TSpeedButton).tag);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if DataReady then  label1.caption:='Yes' else label1.caption:='No'
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Start_PCSU200 then             //1.0
  begin
    Run.enabled:=true;
    Single.enabled:=true;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Stop_PCSU200;                       //1.0
  Run.enabled:=false;
  Single.enabled:=false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Stop_PCSU200;                   //1.0
end;

procedure TForm1.Button4Click(Sender: TObject);
var SettingsArray:array [0..10] of longint;
begin
  if GetSettings(@SettingsArray) then
  begin
    case SettingsArray[0] of
      0: SpeedButton1.Down:=true;
      1: SpeedButton2.Down:=true;
      2: SpeedButton3.Down:=true;
      3: SpeedButton4.Down:=true;
      4: SpeedButton5.Down:=true;
      5: SpeedButton6.Down:=true;
    end;
    case SettingsArray[1] of
      0: SpeedButton13.Down:=true;
      1: SpeedButton14.Down:=true;
      2: SpeedButton15.Down:=true;
      3: SpeedButton18.Down:=true;
      4: SpeedButton17.Down:=true;
      5: SpeedButton16.Down:=true;
    end;
    case SettingsArray[2] of
      0: SpeedButton32.Down:=true;
      1: SpeedButton33.Down:=true;
      2: SpeedButton34.Down:=true;
      3: SpeedButton35.Down:=true;
      4: SpeedButton36.Down:=true;
      5: SpeedButton37.Down:=true;
      6: SpeedButton38.Down:=true;
      7: SpeedButton39.Down:=true;
      8: SpeedButton40.Down:=true;
      9: SpeedButton41.Down:=true;
      10: SpeedButton42.Down:=true;
      11: SpeedButton43.Down:=true;
      12: SpeedButton44.Down:=true;
      13: SpeedButton45.Down:=true;
      14: SpeedButton46.Down:=true;
      15: SpeedButton47.Down:=true;
      16: SpeedButton48.Down:=true;
    end;
    TrackBar1.position:=SettingsArray[3];
    TrackBar2.position:=SettingsArray[4];

    case SettingsArray[5] of
      0: SpeedButton10.Down:=true;
      1: SpeedButton11.Down:=true;
      2: SpeedButton12.Down:=true;
    end;
    case SettingsArray[6] of
      0: SpeedButton22.Down:=true;
      1: SpeedButton23.Down:=true;
      2: SpeedButton24.Down:=true;
    end;
    case SettingsArray[7] of
      0: SpeedButton26.Down:=true;
      1: SpeedButton25.Down:=true;
    end;
    case SettingsArray[8] of
      0: SpeedButton27.Down:=true;
      1: SpeedButton28.Down:=true;
    end;
    case SettingsArray[9] of
      0: SpeedButton31.Down:=true;
      1: SpeedButton30.Down:=true;
    end;
    TrackBar3.position:=SettingsArray[10];
  end;
end;

//------------------ Function Generator ------------------------

procedure TForm1.StringsToFloat;
var s:string;
code:integer;
tmp:real;
begin
  s:=Edit1.text;
  if (Pos(',', s) > 0) then  S[Pos(',', S)] := '.';
  Val(s, tmp, Code);
  if (code=0) then freq:=tmp;
  s:=Edit2.text;
  if (Pos(',', s) > 0) then  S[Pos(',', S)] := '.';
  Val(s, tmp, Code);
  if (code=0) then ampl:=tmp;
  s:=Edit6.text;
  if (Pos(',', s) > 0) then  S[Pos(',', S)] := '.';
  Val(s, tmp, Code);
  if (code=0) then start:=tmp;
  s:=Edit5.text;
  if (Pos(',', s) > 0) then  S[Pos(',', S)] := '.';
  Val(s, tmp, Code);
  if (code=0) then stop:=tmp;
  s:=Edit4.text;
  if (Pos(',', s) > 0) then  S[Pos(',', S)] := '.';
  Val(s, tmp, Code);
  if (code=0) then tim:=tmp;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  StopGen;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  StringsToFloat;
  SetGen(1, freq, ampl);       //1.0
  StartGen;
end;
procedure TForm1.Button6Click(Sender: TObject);
begin
  StringsToFloat;
  SetGen(2, freq, ampl);       //1.0
  StartGen;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  StringsToFloat;
  SetGen(3, freq, ampl);      //1.0
  StartGen;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  StringsToFloat;
  SetLibWave(freq, ampl, PChar(Edit7.text));   //1.0
  StartGen;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  StringsToFloat;
  SetSweep(start, stop, ampl, tim);          //1.0
  StartGen;
end;

end.
