﻿Public Class Form1
    Dim DataBuffer1(0 To 5000) As Integer
    Dim DataBuffer2(0 To 5000) As Integer
    Private Declare Sub ReadCh1 Lib "PCSU200.dll" (ByRef Buffer As Integer)
    Private Declare Sub ReadCh2 Lib "PCSU200.dll" (ByRef Buffer As Integer)
    Private Declare Function DataReady Lib "PCSU200.dll" () As Boolean
    Private Declare Sub Voltage1 Lib "PCSU200.dll" (ByVal Volts As Integer)
    Private Declare Sub Voltage2 Lib "PCSU200.dll" (ByVal Volts As Integer)
    Private Declare Sub Time Lib "PCSU200.dll" (ByVal Rate As Integer)
    Private Declare Sub RunOn Lib "PCSU200.dll" (ByVal Run_on As Integer)
    Private Declare Sub SingleOn Lib "PCSU200.dll" (ByVal Single_on As Boolean)
    Private Declare Sub YPosition1 Lib "PCSU200.dll" (ByVal y_pos As Integer)
    Private Declare Sub YPosition2 Lib "PCSU200.dll" (ByVal y_pos As Integer)
    Private Declare Sub TrgOn Lib "PCSU200.dll" (ByVal trg_on As Integer)
    Private Declare Sub TrgLevel Lib "PCSU200.dll" (ByVal Trg_Level As Integer)
    Private Declare Sub TrgSource Lib "PCSU200.dll" (ByVal Trg_Source As Integer)
    Private Declare Sub TrgEdge Lib "PCSU200.dll" (ByVal Positive_Negative As Integer)
    Private Declare Sub Coupling1 Lib "PCSU200.dll" (ByVal AC_DC_GND As Integer)
    Private Declare Sub Coupling2 Lib "PCSU200.dll" (ByVal AC_DC_GND As Integer)
    Private Declare Sub Show_PCSU200 Lib "PCSU200.dll" (ByVal Visible As Integer)
    Private Declare Function Start_PCSU200 Lib "PCSU200.dll" () As Boolean
    Private Declare Sub Stop_PCSU200 Lib "PCSU200.dll" ()
    Private Declare Function GetSettings Lib "PCSU200.dll" (ByRef SettingsArray As Integer) As Boolean

    Private Declare Sub StartGen Lib "PCSU200.dll" ()
    Private Declare Sub StopGen Lib "PCSU200.dll" ()
    Private Declare Sub SetGen Lib "PCSU200.dll" (ByVal func As Integer, ByVal freq As Single, ByVal ampl As Single)
    Private Declare Sub SetSweep Lib "PCSU200.dll " (ByVal freq1 As Single, ByVal freq2 As Single, ByVal ampl As Single, ByVal time As Single)
    Private Declare Sub SetLibWave Lib "PCSU200.dll " (ByVal freq As Single, ByVal ampl As Single, ByVal Pointer As String)

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        Stop_PCSU200()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Start_PCSU200() Then
            CheckBox1.Enabled = True
            Button5.Enabled = True
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Stop_PCSU200()
        CheckBox1.Enabled = False
        Button5.Enabled = False
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Show_PCSU200(1)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Show_PCSU200(0)
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked Then RunOn(1) Else RunOn(0)
        Button5.Enabled = Not CheckBox1.Checked
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        If DataReady() Then Label1.Text = "Yes" Else Label1.Text = "No"
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        SingleOn(True)
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim i As Integer
        ReadCh1(DataBuffer1(0))
        ReadCh2(DataBuffer2(0))
        ListBox1.Items.Clear()
        ListBox1.Items.Add("Sample rate [Hz]" + Chr(9) + Str(DataBuffer1(0)) + Chr(9) + Str(DataBuffer2(0)))
        ListBox1.Items.Add("Full scale [mV]" + Chr(9) + Str(DataBuffer1(1)) + Chr(9) + Str(DataBuffer2(1)))
        ListBox1.Items.Add("GND level [counts]" + Chr(9) + Str(DataBuffer1(2)) + Chr(9) + Str(DataBuffer2(2)))
        ListBox1.Items.Add("")
        For i = 0 To 4095
            ListBox1.Items.Add("Data(" + Str(i) + ")" + Chr(9) + Chr(9) + Str(DataBuffer1(i + 3)) + Chr(9) + Str(DataBuffer2(i + 3)))
        Next
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        Voltage1(sender.tag)
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        Voltage1(sender.tag)
    End Sub

    Private Sub RadioButton3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
        Voltage1(sender.tag)
    End Sub

    Private Sub RadioButton4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton4.CheckedChanged
        Voltage1(sender.tag)
    End Sub

    Private Sub RadioButton5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton5.CheckedChanged
        Voltage1(sender.tag)
    End Sub

    Private Sub RadioButton6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton6.CheckedChanged
        Voltage1(sender.tag)
    End Sub

    Private Sub RadioButton12_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton12.CheckedChanged
        Voltage2(sender.tag)
    End Sub

    Private Sub RadioButton11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton11.CheckedChanged
        Voltage2(sender.tag)
    End Sub

    Private Sub RadioButton10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton10.CheckedChanged
        Voltage2(sender.tag)
    End Sub

    Private Sub RadioButton9_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton9.CheckedChanged
        Voltage2(sender.tag)
    End Sub

    Private Sub RadioButton8_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton8.CheckedChanged
        Voltage2(sender.tag)
    End Sub

    Private Sub RadioButton7_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton7.CheckedChanged
        Voltage2(sender.tag)
    End Sub

    Private Sub RadioButton18_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton18.CheckedChanged
        Coupling1(sender.tag)
    End Sub

    Private Sub RadioButton17_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton17.CheckedChanged
        Coupling1(sender.tag)
    End Sub

    Private Sub RadioButton16_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton16.CheckedChanged
        Coupling1(sender.tag)
    End Sub

    Private Sub RadioButton15_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton15.CheckedChanged
        Coupling2(sender.tag)
    End Sub

    Private Sub RadioButton14_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton14.CheckedChanged
        Coupling2(sender.tag)
    End Sub

    Private Sub RadioButton13_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton13.CheckedChanged
        Coupling2(sender.tag)
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        YPosition1(-TrackBar1.Value)
    End Sub

    Private Sub TrackBar2_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar2.Scroll
        YPosition2(-TrackBar2.Value)
    End Sub

    Private Sub TrackBar3_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar3.Scroll
        TrgLevel(254 - TrackBar3.Value)
    End Sub

    Private Sub RadioButton21_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton21.CheckedChanged
        TrgOn(sender.tag)
    End Sub

    Private Sub RadioButton20_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton20.CheckedChanged
        TrgOn(sender.tag)
    End Sub

    Private Sub RadioButton22_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton22.CheckedChanged
        TrgSource(sender.tag)
    End Sub

    Private Sub RadioButton19_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton19.CheckedChanged
        TrgSource(sender.tag)
    End Sub

    Private Sub RadioButton24_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton24.CheckedChanged
        TrgEdge(sender.tag)
    End Sub

    Private Sub RadioButton23_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton23.CheckedChanged
        TrgEdge(sender.tag)
    End Sub

    Private Sub RadioButton42_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton42.CheckedChanged
        SetGen(1, CSng(TextBox1.Text), CSng(TextBox2.Text))
        StartGen()
    End Sub

    Private Sub RadioButton43_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton43.CheckedChanged
        SetGen(2, CSng(TextBox1.Text), CSng(TextBox2.Text))
        StartGen()
    End Sub

    Private Sub RadioButton44_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton44.CheckedChanged
        SetGen(3, CSng(TextBox1.Text), CSng(TextBox2.Text))
        StartGen()
    End Sub

    Private Sub RadioButton45_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton45.CheckedChanged
        SetLibWave(CSng(TextBox1.Text), CSng(TextBox2.Text), TextBox4.Text)
        StartGen()
    End Sub

    Private Sub RadioButton46_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton46.CheckedChanged
        SetSweep(CSng(TextBox5.Text), CSng(TextBox6.Text), CSng(TextBox2.Text), CSng(TextBox7.Text))
        StartGen()
    End Sub

    Private Sub RadioButton47_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton47.CheckedChanged
        StopGen()
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim SettingsArray(0 To 10) As Integer
        If GetSettings(SettingsArray(0)) Then
            Select Case SettingsArray(0)
                Case 0
                    RadioButton1.Checked = True
                Case 1
                    RadioButton2.Checked = True
                Case 2
                    RadioButton3.Checked = True
                Case 3
                    RadioButton4.Checked = True
                Case 4
                    RadioButton5.Checked = True
                Case 5
                    RadioButton6.Checked = True
            End Select
            Select Case SettingsArray(1)
                Case 0
                    RadioButton12.Checked = True
                Case 1
                    RadioButton11.Checked = True
                Case 2
                    RadioButton10.Checked = True
                Case 3
                    RadioButton9.Checked = True
                Case 4
                    RadioButton8.Checked = True
                Case 5
                    RadioButton7.Checked = True
            End Select
            Select Case SettingsArray(2)
                Case 0
                    m500.Checked = True
                Case 1
                    m200.Checked = True
                Case 2
                    m100.Checked = True
                Case 3
                    m50.Checked = True
                Case 4
                    m20.Checked = True
                Case 5
                    m10.Checked = True
                Case 6
                    m5.Checked = True
                Case 7
                    m2.Checked = True
                Case 8
                    m1.Checked = True
                Case 9
                    m05.Checked = True
                Case 10
                    m02.Checked = True
                Case 11
                    m01.Checked = True
                Case 12
                    u50.Checked = True
                Case 13
                    u20.Checked = True
                Case 14
                    u10.Checked = True
                Case 15
                    u5.Checked = True
                Case 16
                    u2.Checked = True
            End Select
            Select Case SettingsArray(5)
                Case 0
                    RadioButton18.Checked = True
                Case 1
                    RadioButton17.Checked = True
                Case 2
                    RadioButton16.Checked = True
            End Select
            Select Case SettingsArray(6)
                Case 0
                    RadioButton15.Checked = True
                Case 1
                    RadioButton14.Checked = True
                Case 2
                    RadioButton13.Checked = True
            End Select
            Select Case SettingsArray(7)
                Case 0
                    RadioButton20.Checked = True
                Case 1
                    RadioButton21.Checked = True
            End Select
            Select Case SettingsArray(8)
                Case 0
                    RadioButton22.Checked = True
                Case 1
                    RadioButton19.Checked = True
            End Select
            Select Case SettingsArray(9)
                Case 0
                    RadioButton23.Checked = True
                Case 1
                    RadioButton24.Checked = True
            End Select
            TrackBar1.Value = -SettingsArray(3)
            TrackBar2.Value = -SettingsArray(4)
            TrackBar3.Value = 254 - SettingsArray(10)
        End If
    End Sub

    Private Sub m500_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m500.CheckedChanged
        Time(sender.tag)
    End Sub


    Private Sub m200_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m200.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m100_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m100.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m50_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m50.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m20_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m20.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m10.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m5.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m2.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m1.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m05_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m05.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m02_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m02.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub m01_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m01.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub u50_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles u50.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub u20_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles u20.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub u10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles u10.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub u5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles u5.CheckedChanged
        Time(sender.tag)
    End Sub

    Private Sub u2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles u2.CheckedChanged
        Time(sender.tag)
    End Sub

End Class
